﻿/*
 * Created by SharpDevelop.
 * User: Administrator
 * Date: 2013-3-13
 * Time: 10:58
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Collections.Generic;
using System.Drawing;
using System.Windows.Forms;
using System.Text;
using System.Runtime.InteropServices;

namespace Demo
{
	/// <summary>
	/// Description of MainForm.
	/// </summary>
	public partial class MainForm : Form
	{

		[DllImport("WESmsInterface.dll",EntryPoint = "OpenDevice")]
		private static extern IntPtr OpenDevice(Int32 nPort,Int32 nBaud);

        [DllImport("WESmsInterface.dll", EntryPoint = "SendSMS")]
        private static extern Boolean SendSMS(IntPtr dev, string szNumber ,string szContext);

        [DllImport("WESmsInterface.dll", EntryPoint = "RecvSMS")]
        private static extern Boolean RecvSMS(IntPtr dev, ref IntPtr pMsg, ref Int32 nCount);

        [DllImport("WESmsInterface.dll", EntryPoint = "CloseDevice")]
        private static extern Boolean CloseDevice(IntPtr dev);

        [DllImport("WESmsInterface.dll", EntryPoint = "DismemberedSMS")]
        private static extern Boolean DismemberedSMS(IntPtr dev, int nIndex, StringBuilder szNumber, StringBuilder szTime, StringBuilder szContext);

        IntPtr pDev = IntPtr.Zero;

        public MainForm()
		{
			//
			// The InitializeComponent() call is required for Windows Forms designer support.
			//
			InitializeComponent();
			//
			// TODO: Add constructor code after the InitializeComponent() call.
			//			
		}
		
		void MainFormLoad(object sender, EventArgs e)
		{
			
		}
		
		void Button_RunClick(object sender, EventArgs e)
		{
            Int32 nCom = (Int32)Box_Com.SelectedItem;
            Int32 nBaud = (Int32)Box_Baud.SelectedItem;
            pDev = OpenDevice(nCom, nBaud);
            if (pDev == IntPtr.Zero)
            {
                MessageBox.Show("启动失败.");
                    
            }
            else
            {
                Button_Run.Enabled = false;
                Button_Stop.Enabled = true;
            }
		}
		
		void Button_StopClick(object sender, EventArgs e)
		{
			if (pDev != IntPtr.Zero)
			{
                CloseDevice(pDev);
                Button_Run.Enabled = true;
                Button_Stop.Enabled = false;
			}
		}

        private void Button_Send_Click(object sender, EventArgs e)
        {
            if(pDev != IntPtr.Zero)
            {
                SendSMS(pDev, Edit_Number.Text.ToString(), Edit_Context.Text.ToString());
            }
        }

        private void Button_Recv_Click(object sender, EventArgs e)
        {
            if (pDev != IntPtr.Zero)
            {
                IntPtr pArrMsg = IntPtr.Zero;
                Int32 nCount = 0;
                if (RecvSMS(pDev, ref pArrMsg, ref nCount))
                {
                    if (nCount > 0)
                    {
                        for (int i = 0; i < nCount; i++)
                        {
                            StringBuilder szNum = new StringBuilder(16);
                            StringBuilder szTime = new StringBuilder(50);
                            StringBuilder szContext = new StringBuilder(150);
                            DismemberedSMS(pArrMsg, i,szNum,szTime,szContext);
                            ListViewItem item = new ListViewItem();
                            item.SubItems.Clear();
                            item.SubItems[0].Text = szNum.ToString();
                            item.SubItems.Add(szTime.ToString());
                            item.SubItems.Add(szContext.ToString());
                            List_Msg.Items.Add(item);
                        }
                    }
                    else
                    {
                     //   MessageBox.Show("空");
                    }
                }
            }
        }
	}
}
