// ViewRecv.cpp : implementation file
//

#include "stdafx.h"
#include "Demo.h"
#include "ViewRecv.h"
#include "DemoDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CViewRecv dialog


CViewRecv::CViewRecv(CWnd* pParent /*=NULL*/)
	: CDialog(CViewRecv::IDD, pParent)
{
	//{{AFX_DATA_INIT(CViewRecv)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CViewRecv::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CViewRecv)
		// NOTE: the ClassWizard will add DDX and DDV calls here
		DDX_Control(pDX,IDC_LIST_MSG,m_wndMsgList);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CViewRecv, CDialog)
	//{{AFX_MSG_MAP(CViewRecv)
	ON_BN_CLICKED(IDC_BTN_READ, OnBtnRead)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CViewRecv message handlers

void CViewRecv::OnBtnRead() 
{
	// TODO: Add your control notification handler code here
	CDemoDlg*pDlg = (CDemoDlg*)GetParent();
	if (pDlg->m_pDevice)
	{
		st_message*pMsg;
		int nCount = 0;
		if (RecvSMS(pDlg->m_pDevice,&pMsg,&nCount))
		{
			if (nCount > 0)
			{
				for (int i = 0;i<nCount;i++)
				{
					AddMessage(pMsg[i]);
				}
				FreeMsgArr(&pMsg,nCount);
			}
		}
	}
}

BOOL CViewRecv::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	
	m_wndMsgList.InsertColumn(0,"ֻ",LVCFMT_LEFT,120);
	m_wndMsgList.InsertColumn(1,"ʱ",LVCFMT_LEFT,120);
	m_wndMsgList.InsertColumn(2,"",LVCFMT_LEFT,300);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CViewRecv::AddMessage(st_message &msg)
{
	int nIndex = m_wndMsgList.InsertItem(0,msg.szNumber,0);
	m_wndMsgList.SetItemText(nIndex,1,msg.szTime);
	m_wndMsgList.SetItemText(nIndex,2,msg.szContext);
}
