
#ifndef _SMSFUNC_H_
#define _SMSFUNC_H_

#define DllExport   __declspec( dllexport ) 

struct st_message
{
	char szTime[50];
	char szNumber[16];
	char szContext[150];
};

struct st_device
{
	int nPort;
	int nBaud;
	LPVOID pDevice;
};

extern "C" DllExport st_device*	__cdecl 	OpenDevice(int nPort,int nBaud);

extern "C" DllExport BOOL		__cdecl 	CloseDevice(st_device*pDevice);

extern "C" DllExport BOOL		__cdecl 	SendSMS(st_device*pDev,char*pNumber,char*pContext);

extern "C" DllExport BOOL		__cdecl 	RecvSMS(st_device*pDev,st_message**pMsgArr,int*nCount);

extern "C" DllExport void		__cdecl		DismemberedSMS(st_message*pMsg,int nIndex,char*szNumber,char*szTime,char*szContext);

extern "C" DllExport void		__cdecl 	FreeMsgArr(st_message**pMsgArr,int nCount);

#else
#endif